<template>
  <div class="simple-chart">
    <p v-if="title" class="simple-chart-title">
      <span>{{ title }}</span>
    </p>
    <svg
      :viewBox="`0 0 ${size.width} ${size.height}`"
      xmlns="http://www.w3.org/2000/svg"
    >
      <g fill="none" :stroke-width="size.height / 50">
        <path
          v-for="(row, i) in series"
          :key="`path-${i}`"
          :d="row.path"
          :stroke="getColor(i)"
        />
      </g>
      <g v-for="(row, gi) in series" :key="gi">
        <circle
          v-for="(circle, i) in row.circles"
          :key="`circle-${i}`"
          v-bind="circle"
          fill="white"
          :stroke="getColor(gi)"
        />
        <text
          v-for="(item, i) in row.texts"
          :key="i"
          :x="item.x"
          :y="item.y"
          :fill="getColor(gi)"
          dominant-baseline="middle"
          text-anchor="middle"
        >
          {{ item.text }}
        </text>
      </g>
    </svg>
    <ul class="simple-chart-labels">
      <li v-for="label in labels" :key="label">{{ label }}</li>
    </ul>
  </div>
</template>

<script>
export default {
  name: 'SimpleChart',
  props: {
    options: { type: Object, default: () => {} },
    ratio: { type: Number, default: 9 / 16 },
    title: { type: String, default: '' },
    colors: { type: [Array, String], default: () => ['#c51951'] }
  },
  data() {
    return {}
  },
  computed: {
    labels() {
      return this.options.labels || []
    },
    size() {
      let max = -Infinity
      let min = Infinity
      let width = 1000
      this.options.series.forEach(row => {
        row.forEach(col => {
          if (col > max) max = col
          if (col < min) min = col
        })
      })
      let height = Math.ceil(this.ratio * width)
      if (max === 0) max = height
      min -= (min ? min : max) / 5
      max += max / 2
      return { width, height, min, max }
    },
    series() {
      let series = []
      let size = this.size
      let radius = Math.round(size.width / 100)
      let strokeWidth = Math.round(size.width / 200)
      let xStep = Math.round(size.width / this.labels.length)
      let x = Math.round(xStep / 2)
      this.options.series.forEach(row => {
        let rowItem = { circles: [], texts: [], path: '' }
        row.forEach((col, j) => {
          let y =
            size.height -
            Math.round((col * size.height) / size.max) -
            size.height / 20
          rowItem.path += j ? `L ${x} ${y} ` : `M ${x} ${y} `
          rowItem.circles.push({
            cx: x,
            cy: y,
            r: radius,
            'stroke-width': strokeWidth
          })
          rowItem.texts.push({
            x,
            y: y - size.height / 16,
            text: col
          })
          x += xStep
        })
        series.push(rowItem)
      })
      return series
    }
  },
  methods: {
    getColor(index) {
      if (typeof this.colors === 'string') return this.colors
      let color = this.colors[index]
      if (color === undefined) return color
      return this.colors[0]
    }
  }
}
</script>

<style scoped lang="scss">
@import '../../assets/sass/variables';
.simple-chart {
  position: relative;
  .simple-chart-title {
    text-align: center;
    margin: 0 0 -17px;
    position: relative;
    &:before {
      position: absolute;
      top: 13px;
      height: 3px;
      content: '';
      left: 5%;
      width: 90%;
      background: linear-gradient(
        to right,
        rgba(white, 0) 0%,
        rgba($primary, 0.74) 25%,
        rgba($primary, 1) 50%,
        rgba($primary, 0.74) 75%,
        rgba(white, 0) 100%
      );
    }
    span {
      display: inline-block;
      line-height: 30px;
      padding: 0 15px;
      margin: 0 auto;
      font-size: 0.8rem;
      color: white;
      background-color: lighten($primary, 5%);
      border-radius: 30px;
      position: relative;
      z-index: 1;
    }
  }
  svg {
    border: solid 1px #ccc;
    border-top: 0;
    border-right: 0;
    background-color: #f3f3f3;
    vertical-align: middle;
    text {
      font-size: 25px;
      @media screen and (max-width: 500px) {
        font-size: 35px;
      }
    }
  }
  .simple-chart-labels {
    list-style-type: none;
    display: flex;
    width: 100%;
    margin: 0;
    padding: 0;
    font-size: 0.7rem;
    direction: ltr;
    li {
      flex-grow: 1;
      text-align: center;
      //transform: rotate(60deg);
      transform-origin: left bottom;
    }
  }
}
</style>
